

#ifndef  __FIXED_QUEUE_H__
#define  __FIXED_QUEUE_H__


#include <stdint.h>


#define  FIXED_QUEUE_SIZE   128


extern "C++" {
	namespace avelino {
		using namespace std;

		template <typename T>
		class FixedQueue {
			protected:
				T data[FIXED_QUEUE_SIZE];
				uint16_t outputIndex;
				uint16_t inputIndex;
			public:
				FixedQueue() {
					this->outputIndex = 0;
					this->inputIndex = 0;
				}

				bool isEmpty() {
					return (this->outputIndex == this->inputIndex);
				}

				bool hasData() {
					return (this->outputIndex != this->inputIndex);
				}

				T pop() {
					T ret = this->data[this->outputIndex];
					this->outputIndex++;
					if (this->outputIndex == FIXED_QUEUE_SIZE)
						this->outputIndex = 0;
					return ret;
				}

				void push(T v) {
					this->data[this->inputIndex] = v;
					this->inputIndex++;
					if (this->inputIndex == FIXED_QUEUE_SIZE)
						this->inputIndex = 0;
				}
		};
	}
}

#endif  // __FIXED_QUEUE_H__
