

#ifndef  __LCD20X4_SCREEN_H__
#define  __LCD20X4_SCREEN_H__


#include <stdint.h>
#include "FixedQueue.H"
#include "Lcd20x4.H"


extern "C++" {
	namespace avelino {
		using namespace std;

		class CharacterBitmapEntry {
			public:
				char latin1Char;
				uint8_t bitmap[8];
				uint8_t lcdChar;
				uint8_t lcdFallbackChar;
				uint8_t timesUsed;
				bool loadMark;
				CharacterBitmapEntry(char latin1Char, char lcdFallbackChar, uint8_t row0, uint8_t row1, uint8_t row2, uint8_t row3, uint8_t row4, uint8_t row5, uint8_t row6, uint8_t row7);
		};

		class Lcd20x4Screen : public Lcd20x4 {
			protected:
				FixedQueue<uint8_t> availableLcdChars;
				char physicalDisplay[4][20];
				uint8_t characterBitmapEntryTableSize;
				CharacterBitmapEntry characterBitmapEntryTable[];
				CharacterBitmapEntry *findCharacterBitmapEntry(char c);
				uint8_t replaceChar(char newC, char oldC);
				void printWithReplacement(char *logicalRow, char *physicalRow, uint8_t x, uint8_t xOut);
				virtual CharacterBitmapEntry *getCharacterBitmapEntryTable(uint8_t &size) = 0;
				void loadMarkedCharacterBitmapEntries();
				static char HEX_TABLE[16];
			public:
				char logicalDisplay[4][20];
				void init();
				void run();
				void print(uint8_t x, uint8_t y, const char *s);
				void printHex(uint8_t x, uint8_t y, uint8_t v);
				void printDec(uint8_t x, uint8_t y, uint16_t v);
		};
	}
}

#endif  // __LCD20X4_SCREEN_H__
